#!/usr/bin/env python

# Programmeerperiode juni 2017
# Bedenker/ontwerper/programmeur: H.J. Doornheim, Arnhem
# Platform: Raspbian Jessie - Python 2.7.9

from datetime import datetime
now = datetime.now()
import datetime
import string
import time
import subprocess as sp
import RPi.GPIO as GPIO

GPIO.VERSION
GPIO.setmode(GPIO.BCM)
GPIO.setwarnings(False)
GPIO.setup(17,GPIO.OUT)
GPIO.setup(16,GPIO.OUT)
GPIO.setup(20,GPIO.OUT)
GPIO.setup(27,GPIO.OUT)
GPIO.setup(21,GPIO.OUT)

# GPIO17 = relais 1 (geldig ID)
# GPIO27 = relais 2 (ongeldig ID)
# GPIO16 = led (groen  = geldig ID)
# GPIO21 = led (rood   = ongeldig ID)
# GPIO20 = led (oranje = programma status)

# Pauzes in seconden: goed = tijd bij juiste pas, fout = tijd bij onjuiste pas, pauze = retourtijd voor nieuwe invoer
goed = 2.5
fout = 2.5
pauze = 0.5

# Maak logbestand aan met kopregel en bootmoment
bestand = open("logboek.log","a")
bestand.write("\n==========================================================\n")
bestand.write("    Systeemstart RFID-Reader ")
bestand.write(now.strftime("%d-%m-%Y %H:%M:%S"))
bestand.write("\n==========================================================")
bestand.write("\n")
bestand.close()

# Maak logbestand aan met kopregel en bootmoment
bestand = open("autorisatie.log","a")
bestand.write("\n==========================================================\n")
bestand.write("       Autorisatie logboek per ")
bestand.write(now.strftime("%d-%m-%Y %H:%M:%S"))
bestand.write("\n==========================================================")
bestand.write("\n")
bestand.close()

# Start lus
while True:

# Lees count (aantal swipes) in
    with open("counter.log", "r") as txt:
        for line in txt:
	    count=line

# Wis scherm
    tmp = sp.call('clear',shell=True)

# Stel NU vast
    now = datetime.datetime.now()

# Welkomstscherm
    print ("\033[1;32m")
    print ("\t++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++")
    print ("\t+                                                                    +")
    print ("\t+               R F I D - C A R D / T A G   R E A D E R              +")
    print ("\t+                                                                    +")
    print ("\t+                   T O E G A N G S C O N T R O L E                  +")
    print ("\t+                                                                    +")
    print ("\t++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++")

# Zet programma status LED AAN
    GPIO.output(20,GPIO.HIGH)

# Aantal swipes
    print("\n\tTotaal aantal swipes: "),(count)
    print("")

# variabelen list is het bestand waar in 10 regels met 10 cijfers in had staan
    filename = "list"

# Inlezen string
    searchPattern = raw_input("\tLees de RFID: ")

# tekstkleur uitzetten
    print("\033[1;m")

# Teller met 1 ophogen
    count=int(float(count))
    count=count+1

# Wegschrijven counter (aantal swipes)
    bestand = open("counter.log","w")
    count=str(int(count))
    bestand.write(count)
    bestand.close()

# De zoekfunctie
    def findPattern( pattern ):
        # open file and read all lines
        with open( filename ) as f:
            lines = f.readlines()

        # alle data zit nu in de variabele lines

        # zet foundValue op None
        foundValue =  None

        # doorzoek de data, break maakt dat er uit de for-loop gesprongen wordt
        for line in lines:
            if searchPattern in line:
		 print("        ID verificatie & autorisatie: "),(line)
                 time.sleep(1)

                 # schrijf autorisatielog
                 bestand = open("autorisatie.log","a")
                 bestand.write(now.strftime("%d-%m-%Y %H:%M:%S --> "))
                 bestand.write(line)
                 bestand.close()

                 foundValue = searchPattern
                 break

        # geef de waarde terug, dit is of de gevonden regel of het oorspronkelijke None
        return foundValue

# einde zoekfunctie

# zoek naar het 10 cijferige getal in searchPattern
    returnValue = findPattern( searchPattern )

# spreekt voor zich
    if returnValue is None:
        # print "pattern not found"
        print("")
        print("\t\033[1;41m                                                                      \033[1;m")
        print '\t\033[1;41m                            ONGELDIG ID!                              \033[1;m'
        print("\t\033[1;41m                                                                      \033[1;m")
        print("")

        # schrijf log
        bestand = open("logboek.log","a")
        bestand.write(now.strftime("%d-%m-%Y %H:%M:%S --> "))
        bestand.write(searchPattern + " = ONGELDIGE TAG/PAS! \n")
        bestand.close()

        #stuur poorten (leds en relais)
        GPIO.output(21,GPIO.HIGH)
        GPIO.output(27,GPIO.HIGH)
        time.sleep(fout)
        GPIO.output(21,GPIO.LOW)
        GPIO.output(27,GPIO.LOW)
        GPIO.output(20,GPIO.LOW)
        time.sleep(pauze)

    else:
        # print "found pattern %s" % returnValue
        print("")
        print("\t\033[1;42m                                                                      \033[1;m")
        print("\t\033[1;42m                             GELDIG ID!                               \033[1;m")
        print("\t\033[1;42m                                                                      \033[1;m")
        print("")

        # schrijf log
        bestand = open("logboek.log","a")
        bestand.write(now.strftime("%d-%m-%Y %H:%M:%S --> "))
        bestand.write(searchPattern + " = GELDIGE TAG/PAS! \n")
        bestand.close()

        # stuur poorten (leds en relais)
        GPIO.output(17,GPIO.HIGH)
        GPIO.output(16,GPIO.HIGH)
        time.sleep(goed)
        GPIO.output(17,GPIO.LOW)
        GPIO.output(16,GPIO.LOW)
        GPIO.output(20,GPIO.LOW)
        time.sleep(pauze)

# Einde programma - Have A Nice Day (19-1-2017)

